#include "ktiplabel.h"
#include <QEvent>
#include <QDebug>
KTipLabel::KTipLabel(QWidget *parent)
    : QLabel(parent)
{
    m_strText = "";
}

KTipLabel::KTipLabel(QString strText, QWidget *parent)
{
    m_strText = strText;
}

void KTipLabel::setText(const QString &strText)
{
    m_strText = strText;
    QLabel::setText(strText);
}

void KTipLabel::paintEvent(QPaintEvent *event)
{
    QString strEText = getElidedText(font(),  width() ,m_strText);
    if (strEText == m_strText) {
        QLabel::setText(m_strText);
    } else if (strEText != m_strText ) {
        QLabel::setText(strEText);
    }
    QLabel::paintEvent(event);
}

QString KTipLabel::getElidedText(QFont font,int width,QString strInfo)
{
    QFontMetrics fontMetrics(font);
    //如果当前字体下，字符串长度大于指定宽度
    if(fontMetrics.width(strInfo) > width)
    {
        strInfo= QFontMetrics(font).elidedText(strInfo, Qt::ElideRight, width);
    }
    return strInfo;
}
